# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2011 <Davide Vescovini> <davide.vescovini@gmail.com>
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

################################################################################
############# IMPORTAZIONE MODULI  BASE ########################################
################################################################################
import gtk
################################################################################
############ SUPPORTO INTERNAZIONALIZZAZIONE  ##################################
################################################################################
import gettext
from gettext import gettext as _
gettext.textdomain('preventares')
################################################################################
############ IMPOSTAZIONI LOGGINGS  ############################################
################################################################################
import logging
LOGGING = "PreventaLib"
logging.getLogger(LOGGING)
################################################################################
############# IMPORTAZIONE MODULI ##############################################
################################################################################
from preventares.preventaresconfig import get_config_path
from preventares.preventaresconfig import get_data_path
from preventares.preventaresconfig import get_user_path
################################################################################
### FINESTRA DI SELEZIONE FILE #################################################
################################################################################
class FileChooserDialog():
    """Crea la finestra di dialogo per selezionare file o cartelle"""
    def __init__(self, testo=None, mode=None, filetype=None, 
                 default_path=get_config_path()):
        if testo is None: 
            testo = _("Scegli un file")
        if mode == "save" or mode == "new":
            action = gtk.FILE_CHOOSER_ACTION_SAVE
            button = gtk.STOCK_SAVE
        elif mode == "folder":
            action = gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER
            button = gtk.STOCK_OPEN
        else:
            action = gtk.FILE_CHOOSER_ACTION_OPEN
            button = gtk.STOCK_OPEN
        # crea la finestra di dialogo filechooser
        self.dialog = gtk.FileChooserDialog(testo, None, action, (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, button, gtk.RESPONSE_OK))
        self.dialog.set_default_response(gtk.RESPONSE_OK)
        # se è in save mode imposta la conferma x sovrascrittura dei file
        if mode == "save" or mode == "new":
            self.dialog.set_do_overwrite_confirmation(True)
        # imposta la path di default
        if default_path is not None:
            self.dialog.set_current_folder(default_path)
        # aggiungi la path di default ai preferiti
        if default_path != get_user_path():
            self.dialog.add_shortcut_folder(default_path)
        if default_path != get_data_path():
            self.dialog.add_shortcut_folder(get_data_path())
        # filtro per tutti i file (default)
        filter = gtk.FileFilter()
        filter.set_name("All files")
        filter.add_pattern("*")
        self.dialog.add_filter(filter)
        self.dialog.set_filter(filter)
        if filetype=="csv" or filetype=="txt":
            # filtro per i file testo
            filter2 = gtk.FileFilter()
            filter2.set_name("File %s" % filetype)
            filter2.add_mime_type("plain/text")
            filter2.add_pattern("*.csv")
            filter2.add_pattern("*.txt")
            self.dialog.add_filter(filter2)
            self.dialog.set_filter(filter2)
        elif filetype=="pwe":
            # filtro per i file interscambio PRIMUS
            filter2 = gtk.FileFilter()
            filter2.set_name("File PWE")
            filter2.add_mime_type("plain/text")
            filter2.add_pattern("*.pwe")
            self.dialog.add_filter(filter2)
            self.dialog.set_filter(filter2)
        elif filetype=="xml":
            # filtro per i file XML
            filter2 = gtk.FileFilter()
            filter2.set_name("File XML")
            filter2.add_mime_type("application/xml")
            #filter2.add_pattern("*.xml")
            self.dialog.add_filter(filter2)
            self.dialog.set_filter(filter2)
        else:
            # filtro per i file database sqlite3
            filter1 = gtk.FileFilter()
            filter1.set_name("Database SQLITE")
            filter1.add_mime_type("application/x-sqlite3")
            #filter1.add_pattern("*.db")
            self.dialog.add_filter(filter1)
            self.dialog.set_filter(filter1)

    def run(self):
        # attiva la finestra di dialogo
        response = self.dialog.run()
        if response == gtk.RESPONSE_OK:
            file = self.dialog.get_filename()
        elif response == gtk.RESPONSE_CANCEL:
            file = None
        else:
            file = None
        self.dialog.destroy()
        logging.debug(_("File/Cartella selezionato: '{0}'").format(file))
        return file

####################################################################################
###  NON MODIFICARE ################################################################
####################################################################################
if __name__ == "__main__":
    dialog = FileChooserDialog()
    dialog.show()
    gtk.main()
